/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips;

import ru.ispras.microtesk.model.api.ProcessorModel;
import ru.ispras.microtesk.model.api.metadata.MetaModelPrinter;
import ru.ispras.microtesk.model.api.state.ModelStatePrinter;
import ru.ispras.microtesk.model.api.instruction.AddressingMode;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.minimips.mode.*;
import ru.ispras.microtesk.model.minimips.op.*;

import static ru.ispras.microtesk.model.minimips.Shared.*;

public final class Model extends ProcessorModel {
  public static final String NAME = "minimips";

  private static final AddressingMode.IInfo[] __MODES = new AddressingMode.IInfo[] {
    REG.INFO,
    COP0.INFO
  };

  private static final AddressingMode.IInfo[] __MODE_GROUPS = new AddressingMode.IInfo[] {
  };

  private static final Operation.IInfo[] __OPS = new Operation.IInfo[] {
    add.INFO,
    addi.INFO,
    addu.INFO,
    addiu.INFO,
    sub.INFO,
    subu.INFO,
    mult.INFO,
    multu.INFO,
    and.INFO,
    andi.INFO,
    or.INFO,
    ori.INFO,
    nor.INFO,
    xor.INFO,
    xori.INFO,
    sll.INFO,
    sllv.INFO,
    sra.INFO,
    srav.INFO,
    srl.INFO,
    srlv.INFO,
    lui.INFO,
    lw.INFO,
    sw.INFO,
    mfhi.INFO,
    mflo.INFO,
    mthi.INFO,
    mtlo.INFO,
    swc0.INFO,
    lwc0.INFO,
    mfc0.INFO,
    mtc0.INFO,
    beq.INFO,
    bgez.INFO,
    bgezal.INFO,
    bgtz.INFO,
    blez.INFO,
    bltz.INFO,
    bltzal.INFO,
    bne.INFO,
    slt.INFO,
    slti.INFO,
    sltiu.INFO,
    sltu.INFO,
    j.INFO,
    jr.INFO,
    jal.INFO,
    jalr.INFO,
    syscall.INFO,
    cop0.INFO,
    mips_break.INFO,
    instruction.INFO,
    la.INFO
  };

  private static final Operation.IInfo[] __OP_GROUPS = new Operation.IInfo[] {
    arithm.INFO,
    arithmi.INFO,
    multiply.INFO,
    bitwise.INFO,
    bitwisei.INFO,
    shift.INFO,
    shifti.INFO,
    alu.INFO,
    alui.INFO,
    Operations.INFO
  };

  public Model() {
    super(
        NAME,
        __MODES,
        __MODE_GROUPS,
        __OPS,
        __OP_GROUPS,
        __REGISTERS,
        __MEMORY,
        __VARIABLES,
        __LABELS
        );
  }

  public static void printInformation() {
    final Model model = new Model();

    final MetaModelPrinter metaModelPrinter = new MetaModelPrinter(model.getMetaData());
    metaModelPrinter.printAll();

    final ModelStatePrinter modelStatePrinter = new ModelStatePrinter(model);
    modelStatePrinter.printRegisters();
  }

  public static void main(String[] args) {
    printInformation();
  }
}
 