/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.minimips.Shared.*;

public final class cop0 extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         cop0.class,
         "cop0",
         false,
         new ArgumentDecls()
             .add("cop_fun", Type.CARD(21)),
         false,
         false,
         false,
         false,
         false,
         0,
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final Immediate cop_fun = (Immediate) getArgument("cop_fun", args);

      return new cop0(cop_fun);
    }
  }

  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "cop0",
          true,
          new ArgumentDecls()
              .add("cop_fun", Type.CARD(21)),
          true,
          true,
          false,
          false,
          false,
          0
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final Immediate cop_fun = (Immediate) getArgument("cop_fun", args);

      return new instruction(
        new cop0(
          cop_fun
        )
      );
    }
  }

  public static final IInfo INFO = new Info();

  public final Immediate cop_fun;

  public cop0(final Immediate cop_fun) {
    assert Type.CARD(21).equals(cop_fun.getType());
    this.cop_fun = cop_fun;
  }

  @Override
  public String syntax() {
    return String.format("cop0 %s", cop_fun.access().load().toString());
  }

  @Override
  public String image() {
    return String.format("01000000001%s", cop_fun.access().load().toString());
  }

  @Override
  public void action() {
  }
}
