/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.minimips.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.minimips.Shared.*;

public final class sll extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         sll.class,
         "sll",
         false,
         new ArgumentDecls()
             .add("rd", ArgumentMode.OUT, REG.INFO)
             .add("rt", ArgumentMode.IN, REG.INFO)
             .add("sa", Type.CARD(5)),
         false,
         false,
         false,
         false,
         false,
         0,
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final REG rd = (REG) getArgument("rd", args);
      final REG rt = (REG) getArgument("rt", args);
      final Immediate sa = (Immediate) getArgument("sa", args);

      return new sll(rd, rt, sa);
    }
  }

  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "sll",
          true,
          new ArgumentDecls()
              .add("rd", ArgumentMode.OUT, REG.INFO)
              .add("rt", ArgumentMode.IN, REG.INFO)
              .add("sa", Type.CARD(5)),
          true,
          true,
          false,
          false,
          false,
          0
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final REG rd = (REG) getArgument("rd", args);
      final REG rt = (REG) getArgument("rt", args);
      final Immediate sa = (Immediate) getArgument("sa", args);

      return new instruction(
        new sll(
          rd,
          rt,
          sa
        )
      );
    }
  }

  public static final IInfo INFO = new Info();

  public final REG rd;
  public final REG rt;
  public final Immediate sa;

  public sll(final REG rd, final REG rt, final Immediate sa) {
    assert REG.INFO.isSupported(rd);
    assert REG.INFO.isSupported(rt);
    assert Type.CARD(5).equals(sa.getType());
    this.rd = rd;
    this.rt = rt;
    this.sa = sa;
  }

  @Override
  public String syntax() {
    return String.format("sll %s, %s, %d", rd.syntax(), rt.syntax(), sa.access().load().bigIntegerValue());
  }

  @Override
  public String image() {
    return String.format("00000000000%s%s%s000000", rt.image(), rd.image(), sa.access().load().toString());
  }

  @Override
  public void action() {
    rd.access().store(rt.access().load().shiftLeft(sa.access().load()));
  }
}
