/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.vliw.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.vliw.Shared.*;

public final class BEQ extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         BEQ.class,
         "BEQ",
         false,
         new ArgumentDecls()
             .add("rs", ArgumentMode.IN, R.INFO)
             .add("rt", ArgumentMode.IN, R.INFO)
             .add("offset", SHORT),
         false,
         false,
         false,
         false,
         false,
         0);
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rs = (R) getArgument("rs", args);
      final R rt = (R) getArgument("rt", args);
      final Immediate offset = (Immediate) getArgument("offset", args);

      return new BEQ(rs, rt, offset);
    }
  }

  public static final IInfo INFO = new Info();

  public final R rs;
  public final R rt;
  public final Immediate offset;

  public BEQ(final R rs, final R rt, final Immediate offset) {
    assert R.INFO.isSupported(rs);
    assert R.INFO.isSupported(rt);
    assert SHORT.equals(offset.getType());
    this.rs = rs;
    this.rt = rt;
    this.offset = offset;
  }

  @Override
  public String syntax() {
    return String.format("BEQ %s, %s, <label>%d", rs.syntax(), rt.syntax(), offset.access().load().bigIntegerValue());
  }

  @Override
  public String image() {
    return String.format("000100%s%s%s", rs.image(), rt.image(), offset.access().load().toString());
  }

  @Override
  public void action() {
    if (rs.access().load().equals(rt.access().load())) {
      BRANCH.access().store(Data.valueOf(BIT, 0x1));
      JMPADDR.access().store(NIA.access().load().add(Data.signExtend(WORD, offset.access().load()).shiftLeft(Data.valueOf(WORD, 0x3))));
    }
  }
}
